// PAnalysisResultManager.h: interface for the PAnalysisResultManager class.
//
//////////////////////////////////////////////////////////////////////

/* #if !defined(AFX_PANALYSISRESULTMANAGER_H__1C6C2712_6E09_472E_88F9_1A539401C97A__INCLUDED_)
#define AFX_PANALYSISRESULTMANAGER_H__1C6C2712_6E09_472E_88F9_1A539401C97A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000 */

#ifndef __PANALYSIS_RESULT_MANAGER_H__
#define __PANALYSIS_RESULT_MANAGER_H__

#include "PBuffer.h"
#include "unistd.h"
#include "PStringToken.h"
#include "../../include/AnalysisModuleInterface.h"

#define STX				"!@"
#define ETX 				"#$"

enum 
{
	CORRECT_ONE_DATA = 0,
	ERROR_ONE_DATA,
};

class PAnalysisResultManager  
{
private:
	PBuffer m_Buffer;
	CAnalysisNotifyInterface*	m_pAnalysisNotifyInterface;
	CModuleRelayInterface* 		m_pModuleRelayInterface;

	unsigned int 			m_uiModuleId;
	pid_t				m_nModulePId;

	int FindAfter( int nAfter , int nLength , char* pBuffer , const char* pFindText );
	void ProcessOneData( int nType , char* pBuffer , int nLength );

public:
	PAnalysisResultManager();
	// PAnalysisResultManager( CAnalysisNotifyInterface* pAnalysisNotifyInterface  );
	PAnalysisResultManager( CAnalysisNotifyInterface* pAnalysisNotifyInterface , CModuleRelayInterface* pModuleRelayInterface );
	~PAnalysisResultManager();

	PBuffer*		GetBuffer();
	CModuleRelayInterface*	GetModuleRelayInterface();
	pid_t			GetModulePid();

	void SetModulePId( char* pBuffer , int nBufferUsedLength );

	void Initialize( unsigned int m_uiModuleId , CAnalysisNotifyInterface* pAnalysisNotifyInterface , CModuleRelayInterface* pModuleRelayInterface );
	void AddAnalysisResult( char* pBuffer , int nLength );
	
	void ProcessBufferData( bool IsEnd = false );
	void ProcessBufferErrorData( bool IsEnd = false );
	void ProcessAnalysisError( char* pBuffer , int nLength );
	void ProcessAnalysisState( PStringToken* pStringToken , int nLength );
	void ProcessAnalysisResult( char* pszFileName , char* pszErrorText , int nLineNo );
	bool IsBufferOverFlowErrorMessage( char* pBuffer , int nIndex );
};

#endif // !defined(AFX_PANALYSISRESULTMANAGER_H__1C6C2712_6E09_472E_88F9_1A539401C97A__INCLUDED_)
