#include "stdio.h"
#include "stdlib.h"
#include "string.h"
#include "PString.h"

PString::PString()
{
	m_pString = NULL;
}

PString::~PString()
{
	FreeBuffer();
}

PString::PString( char* pData )
{
	int nDataSize = strlen( pData );

	m_pString = ( char* )malloc( nDataSize ) + 1;
	memset( m_pString , 0 , nDataSize + 1 );

	if( pData )
	{
		strncpy( m_pString , pData , nDataSize );
	}
}

PString::PString( int nDataSize )
{
	AllocateBuffer( nDataSize );
	/* m_pString = ( char* )malloc( nDataSize ) + 1;
	memset( m_pString , 0 , nDataSize + 1 );

	if( pData )
	{
		strncpy( m_pString , pData , nDataSize );
	} */
}

char* PString::GetString()
{
	return m_pString;
}

void PString::FreeBuffer()
{
	if( m_pString )
	{
		delete [] m_pString;
		m_pString = NULL;
	}
}

bool PString::AllocateBuffer( int nSize )
{
	m_pString = ( char* )malloc( nSize );
	if( NULL == m_pString )
	{
		return false;
	}
	memset( m_pString , 0 , nSize );

	return true;
}

void PString::StringReplace( char* pTargetString , char* pReplaceString  )
{
	int i = 0;

	for( i = 0 ; ( i < strlen( m_pString ) ) && ( '\0' != ( *m_pString ) ) ; i++ )
	{
		if( 0 == strncmp( m_pString + i , pTargetString , strlen( pTargetString ) ) )
		{
			memcpy( m_pString + i , pReplaceString , strlen( pReplaceString ) );

			i += ( strlen( pReplaceString ) - 1 );
		}
	}
}
