// PAnalysisResultManager.cpp: implementation of the PAnalysisResultManager class.
//
//////////////////////////////////////////////////////////////////////

// #include "stdafx.h"
// #include "../include/AnalysisModuleInterface.h"
// #include "PBuffer.h"
#include "PStringToken.h"
#include "AnalysisResultManager.h"
#include "string.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

PAnalysisResultManager::PAnalysisResultManager()
{
	m_pAnalysisNotifyInterface	= NULL;
	m_pModuleRelayInterface		= NULL;
	m_uiModuleId			= 0;
	m_nModulePId			= 0;
}

// PAnalysisResultManger::PAnalysisResultManager( CAnalysisNotifyInterface* pAnalysisNotifyInterface  );
PAnalysisResultManager::PAnalysisResultManager( CAnalysisNotifyInterface* pAnalysisNotifyInterface , CModuleRelayInterface* pModuleRelayInterface )
{
	m_pAnalysisNotifyInterface = pAnalysisNotifyInterface;
	m_pModuleRelayInterface = pModuleRelayInterface;
}

PAnalysisResultManager::~PAnalysisResultManager()
{
}

PBuffer* PAnalysisResultManager::GetBuffer()
{
	return &m_Buffer;
}

CModuleRelayInterface* PAnalysisResultManager::GetModuleRelayInterface()
{
	return m_pModuleRelayInterface;
}	

pid_t PAnalysisResultManager::GetModulePid()
{
	return m_nModulePId;
}

void PAnalysisResultManager::SetModulePId( char* pBuffer , int nBufferUsedLength )
{
	char* pPid	= NULL;
	// char* pBuffer	= m_Buffer.GetBuffer();

	int nPidLength	= 0;

	// int nBufferUsedLength = m_Buffer.GetBufferUsedLength();

	int nStartIndex = FindAfter( 0 , nBufferUsedLength , pBuffer , "!@" );
	int nEndIndex	= FindAfter( 0 , nBufferUsedLength , pBuffer , "#$" );

	// printf( "Start Index = %d , End Index = %d \n" , nStartIndex , nEndIndex );
	
	nPidLength = nEndIndex - ( 2 + nStartIndex );
	// printf( "nPidLength = %d\n" , nPidLength );
	pPid = ( char* )malloc( nPidLength + 1 );

	memset( pPid , 0 , nPidLength + 1 );
	strncpy( pPid , pBuffer + ( nStartIndex + 2 ) , nPidLength );

	m_nModulePId = atoi( pPid );
	printf( "Module Pid = %d\n" , m_nModulePId );

	if( NULL == pPid )
	{
		free( pPid );
	}

	/* char  caPid[ 10 ];
	char* pBuffer		= m_Buffer.GetBuffer();

	int nPidLength		= 0;

	int nBufferUsedLength = m_Buffer.GetBufferUsedLength();

	int nStartIndex = FindAfter( 0 , nBufferUsedLength , pBuffer , "!@" );
	int nEndIndex	= FindAfter( 0 , nBufferUsedLength , pBuffer , "#$" );

	// printf( "Start Index = %d , End Index = %d \n" , nStartIndex , nEndIndex );
	
	nPidLength = nEndIndex - ( 2 + nStartIndex );
	// printf( "nPidLength = %d\n" , nPidLength );

	memset( caPid , 0 , sizeof( caPid ) );
	memcpy( caPid , ( pBuffer + ( 2 + nStartIndex ) ) , nPidLength );

	m_nModulePId = atoi( caPid );
	printf( "Pid =%d\n" , m_nModulePId ); */
}

void PAnalysisResultManager::Initialize( unsigned int uiModuleId , CAnalysisNotifyInterface* pAnalysisNotifyInterface , CModuleRelayInterface* pModuleRelayInterface )
{
	m_uiModuleId = uiModuleId;
	m_pAnalysisNotifyInterface = pAnalysisNotifyInterface;
	m_pModuleRelayInterface = pModuleRelayInterface;
}

void PAnalysisResultManager::AddAnalysisResult( char* pBuffer, int nLength )
{
	if( nLength  > 0 )
	{
		m_Buffer.AddTail( pBuffer, nLength );
	}
}

void PAnalysisResultManager::ProcessBufferData( bool IsEnd )
{
	/* if( 0 == m_nModulePId )
	{
		printf( "In Pid\n" );
		SetModulePId();
	} */

	if( IsEnd )
	{
		m_Buffer.UsedLength( m_Buffer.GetBufferUsedLength() );
		return;
	}

	char* pBuffer 			= m_Buffer.GetBuffer();
	char* pszFileName		= NULL;
	char* pszLineNo			= NULL;
	char* pszErrorText		= NULL;
	char* pszToken			= NULL;

	char pSep[] = ":";

	int nLineNo			= 0;
	int nBufferUsedLength		= m_Buffer.GetBufferUsedLength();

	PStringToken	StringToken;

	// printf( "pBuffer = %s\n" , pBuffer );
	while( nBufferUsedLength > 0 )
	{
		int nIndex = FindAfter( 0 , nBufferUsedLength , pBuffer , "\n" );
		// printf( "One Line Text In Buffer = %s\n" , pBuffer );
		// printf( "nIndex = %d\n" , nIndex );
		if( nIndex == -1 )
		{
			break;
		}
		
		/* if( nIndex == 0 )
		{
			// 여기서 분석을 수행
		}
		else */
		if( nIndex > 0 )
		{
			if( 0 == m_nModulePId )
			{
				// printf( "In Pid Set\n" );
				SetModulePId( pBuffer , nBufferUsedLength );
			}

			StringToken.CreateTokenBuf( pBuffer , nIndex );
			// printf( "Get Buffer = %s\n" , StringToken.GetTokenBuffer() );
			
			pszFileName = StringToken.GetFirstToken( pSep );
			// printf( "pszFileName = %s , strlen( pszFileNameSize ) = %d\n" , pszFileName , strlen( pszFileName ) );

			if( FindAfter( 0 , strlen( pszFileName ) , pszFileName , ".c" ) > 0 )
			{
				pszLineNo = StringToken.GetNextToken( pSep );
				if( NULL != pszLineNo )
				{
					// printf( "pszLineNo = %s\n" , pszLineNo );
					pszToken = StringToken.GetNextToken( pSep );
					if( NULL != pszToken )
					{
						pszErrorText = StringToken.GetNextToken( "\n" );
						if( NULL != pszErrorText )
						{
							nLineNo = atoi( pszLineNo );
							/* printf( "pszFileName = %s , strlen( pszFileNameSize ) = %d\n" , pszFileName , strlen( pszFileName ) );
							printf( "pszLineNo = %d\n" , nLineNo );
							printf( "pszErrorText = %s\n" , pszErrorText ); 
							*/

							ProcessAnalysisResult( pszFileName , pszErrorText , nLineNo );
						}
					}
				}
			}
			else
			{
			}
			StringToken.DeleteTokenBuf();
		}

		m_Buffer.UsedLength( nIndex + 1 );
		nBufferUsedLength = m_Buffer.GetBufferUsedLength();
	}
}

void PAnalysisResultManager::ProcessBufferErrorData( bool IsEnd )
{
	char* pBuffer 			= m_Buffer.GetBuffer();
	char* pszToken			= NULL;

	int nLineNo			= 0;
	int nBufferUsedLength		= m_Buffer.GetBufferUsedLength();

	while( nBufferUsedLength > 0 )
	{
		int nIndex = FindAfter( 0 , nBufferUsedLength , pBuffer , "\n" );
		// printf( "nIndex = %d\n" , nIndex );
		if( nIndex == -1 )
		{
			break;
		}
		
		if( nIndex > 0 )
		{
			// printf( "In ProcessBufferErrorData pBuffer = %s , %d\n" , pBuffer , nIndex );
			ProcessAnalysisError( pBuffer , nIndex );
		}

		m_Buffer.UsedLength( nIndex + 1 );
		nBufferUsedLength = m_Buffer.GetBufferUsedLength();
		// printf( "pBuffer = %s , nBufferUsedLength = %d\n" , pBuffer , nBufferUsedLength  );
	}
}

void PAnalysisResultManager::ProcessAnalysisResult( char* pszFileName , char* pszErrorText , int nLineNo )
{
	CAnalysisResultPin AnalysisResultPin;

	int nFileNameSize	= 0;
	int nErrorTextSize	= 0;

	/*
 * 	printf( "pszFileName = %s , strlen( pszFileNameSize ) = %d\n" , pszFileName , strlen( pszFileName ) );
	printf( "pszLineNo = %d\n" , nLineNo );
	printf( "pszErrorText = %s\n" , pszErrorText ); 
	*/

	nFileNameSize = strlen( pszFileName );
	AnalysisResultPin.m_pszFileName = new char[ nFileNameSize + 1 ];
	memset( AnalysisResultPin.m_pszFileName , 0 , nFileNameSize + 1 );

	strncpy( AnalysisResultPin.m_pszFileName , pszFileName , nFileNameSize );
	// printf( "In CORRECT_ONE_DATA = %s\n" , AnalysisResultPin.m_pszFileName );
			
	AnalysisResultPin.m_nLineNo = nLineNo;
	// printf( "In CORRECT_ONE_DATA = %d\n" , AnalysisResultPin.m_nLineNo );

	nErrorTextSize = strlen( pszErrorText );
	AnalysisResultPin.m_pszErrorText = new char[ nErrorTextSize + 1 ];
	memset( AnalysisResultPin.m_pszErrorText , 0 , nErrorTextSize + 1 );

	strncpy( AnalysisResultPin.m_pszErrorText , pszErrorText , nErrorTextSize );
	// printf( "In CORRECT_ONE_DATA = %s\n" , AnalysisResultPin.m_pszErrorText );

	if( m_pAnalysisNotifyInterface )
	{	
		m_pAnalysisNotifyInterface->OnNotifyAnalysisResult( m_uiModuleId , &AnalysisResultPin );
	}
}

int PAnalysisResultManager::FindAfter( int nAfter , int nLength , char* pBuffer , const char* pFindText )
{
	if( nLength < 2 )
	{
		return -1;
	}

	for( int i = nAfter ; i <= nLength - strlen( pFindText )  ; i++ )
	{
		if( 0 == strncmp( pBuffer + i , pFindText , strlen( pFindText ) ) )
		{
			return i;
		}
	}

	return -1;
}

void PAnalysisResultManager::ProcessOneData( int nType , char* pBuffer , int nLength )
{
	if( nLength <= 0 )
	{
		return;
	}

	switch( nType )
	{
	case CORRECT_ONE_DATA: 
		{
			/* const char aSep[] = "|";
			char* szTokenData = NULL;
			
			int nType = 0;

			PStringToken StringToken;

			StringToken.CreateTokenBuf( pBuffer , nLength );
			szTokenData = StringToken.GetFirstToken( aSep );

			nType = atoi( szTokenData );
			// printf( "nType = %d\n", nType );
			/if( 0 == nType )
			{
				ProcessAnalysisResult( &StringToken , nLength );
			}
			else if( 1 == nType )
			{
				ProcessAnalysisState( &StringToken , nLength );
			}
			else
			{
			}
			
			StringToken.DeleteTokenBuf(); */
		}
		break;
	case ERROR_ONE_DATA:
		{
			// ProcessAnalysisError( pBuffer , nLength );
		}
		break;
	}
}

// void PAnalysisResultManager::ProcessAnalysisState( char* pBuffer , int nLength )
void PAnalysisResultManager::ProcessAnalysisState( PStringToken* pStringToken , int nLength )
{
	int nTextSize = 0;
	int nProcessRate = 0;

	char* pszText = NULL;
	char* pszTokenData = NULL;
	
	const char aSep[] = "|";

	CNotifyProcessState ProcessState;
	ProcessState.m_uiModuleId = m_uiModuleId; 

	pszTokenData = pStringToken->GetNextToken( aSep );
	nProcessRate = atoi( pszTokenData );
	// printf( "Process Rate = %d\n", nProcessRate );

	ProcessState.m_nProcessRate = nProcessRate;

	pszTokenData = pStringToken->GetNextToken( aSep );
	// printf( "Process Text = %s\n", pszTokenData );
	nTextSize = strlen( pszTokenData );
	ProcessState.m_pszText = new char[ nTextSize + 1 ];
	memset( ProcessState.m_pszText , 0 , nTextSize + 1 );

	strncpy( ProcessState.m_pszText , pszTokenData , nTextSize );

	if( m_pAnalysisNotifyInterface )
	{
		m_pAnalysisNotifyInterface->OnNotifyProcessState( &ProcessState );
	}	
}

void PAnalysisResultManager::ProcessAnalysisError( char* pBuffer , int nLength )
{
	char* pData = NULL;

	pData = new char[ nLength + 1 ];
	memset( pData , 0 , nLength + 1 );
	memcpy( pData , pBuffer , nLength );

	// Error No 를 우선 0으로 처리
	m_pAnalysisNotifyInterface->OnNotifyError( m_uiModuleId , 0 , pData );
	
	if( pData )
	{
		delete [] pData;
		pData = NULL;
	}
}
